/*
  Hatari - dlgMain.c

  This file is distributed under the GNU Public License, version 2 or at
  your option any later version. Read the file gpl.txt for details.

  The main dialog.
*/
const char DlgMain_fileid[] = "Hatari dlgMain.c : " __DATE__ " " __TIME__;

#include "main.h"
#include "configuration.h"
#include "dialog.h"
#include "sdlgui.h"
#include "screen.h"
//benoa
#include "ikbd.h"
#include "joy.h"
//

#define MAINDLG_ABOUT    2
#define MAINDLG_SYSTEM   3
#define MAINDLG_ROM      4
#define MAINDLG_MEMORY   5
#define MAINDLG_FLOPPYS  6
#define MAINDLG_HARDDISK 7
#define MAINDLG_SCREEN   8
#define MAINDLG_SOUND    9
#define MAINDLG_JOY      10
#define MAINDLG_KEYBD    11
#define MAINDLG_DEVICES  12
#define MAINDLG_LOADCFG  13
#define MAINDLG_SAVECFG  14
#define MAINDLG_NORESET  15
#define MAINDLG_RESET    16
#define MAINDLG_OK       17
#define MAINDLG_QUIT     18
#define MAINDLG_CANCEL   19

/* Basic virtual keyboard */
#define KEYDLG_F1    2
#define KEYDLG_F2   3
#define KEYDLG_F3      4
#define KEYDLG_F4   5
#define KEYDLG_F5  6
#define KEYDLG_F6 7
#define KEYDLG_F7   8
#define KEYDLG_F8    9
#define KEYDLG_F9      10
#define KEYDLG_F10    11

#define KEYDLG_ESC  12
#define KEYDLG_1  13
#define KEYDLG_2  14
#define KEYDLG_3    15
#define KEYDLG_4       16
#define KEYDLG_5     17
#define KEYDLG_6   18
#define KEYDLG_7   19
#define KEYDLG_8   20
#define KEYDLG_9   21
#define KEYDLG_0   22
#define KEYDLG_10   23
#define KEYDLG_11   24
#define KEYDLG_12   25
#define KEYDLG_BACKSPACE   26

#define KEYDLG_TAB   27
#define KEYDLG_Q   28
#define KEYDLG_W   29
#define KEYDLG_E   30
#define KEYDLG_R   31
#define KEYDLG_T   32
#define KEYDLG_Y   33
#define KEYDLG_U   34
#define KEYDLG_I   35
#define KEYDLG_O   36
#define KEYDLG_P   37
#define KEYDLG_LBRACKET   38
#define KEYDLG_RBRACKET   39
#define KEYDLG_RETURN   40
#define KEYDLG_DEL   41

#define KEYDLG_CONTROL   42
#define KEYDLG_A   43
#define KEYDLG_S   44
#define KEYDLG_D   45
#define KEYDLG_F   46
#define KEYDLG_G   47
#define KEYDLG_H   48
#define KEYDLG_J   49
#define KEYDLG_K   50
#define KEYDLG_L   51
#define KEYDLG_SEMICOLON   52
#define KEYDLG_APOSTROPHE   53
#define KEYDLG_SHARP   54

#define KEYDLG_LEFTSHIFT   55
#define KEYDLG_BACKSLASH  56
#define KEYDLG_Z   57
#define KEYDLG_X   58
#define KEYDLG_C   59
#define KEYDLG_V   60
#define KEYDLG_B   61
#define KEYDLG_N   62
#define KEYDLG_M   63
#define KEYDLG_COLON   64
#define KEYDLG_DOT   65
#define KEYDLG_SLASH  66
#define KEYDLG_RIGHTSHIFT   67

#define KEYDLG_ALTERNATE   68
#define KEYDLG_SPACE   69
#define KEYDLG_CAPSLOCK   70

#define KEYDLG_CLOSE   71
#define KEYDLG_TIME   72
int keypressed=0;


/* The main dialog: */
static SGOBJ maindlg[] =
{
	{ SGBOX, 0, 0, 0,0, 50,19, NULL },
	{ SGTEXT, 0, 0, 17,1, 16,1, "Hatari main menu" },
	{ SGBUTTON, 0, 0, 2,4, 14,1, "About" },
	{ SGBUTTON, 0, 0, 2,6, 14,1, "System" },
	{ SGBUTTON, 0, 0, 2,8, 14,1, "ROM" },
	{ SGBUTTON, 0, 0, 2,10, 14,1, "Memory" },
	{ SGBUTTON, 0, 0, 18,4, 14,1, "Floppy disks" },
	{ SGBUTTON, 0, 0, 18,6, 14,1, "Hard disks" },
	{ SGBUTTON, 0, 0, 18,8, 14,1, "Screen" },
	{ SGBUTTON, 0, 0, 18,10, 14,1, "Sound" },
	{ SGBUTTON, 0, 0, 34,4, 14,1, "Joysticks" },
	{ SGBUTTON, 0, 0, 34,6, 14,1, "Keyboard" },
	{ SGBUTTON, 0, 0, 34,8, 14,1, "Devices" },
	{ SGBUTTON, 0, 0, 7,13, 16,1, "Load config." },
	{ SGBUTTON, 0, 0, 27,13, 16,1, "Save config." },
	{ SGRADIOBUT, 0, 0, 3,15, 10,1, "No Reset" },
	{ SGRADIOBUT, 0, 0, 3,17, 10,1, "Reset machine" },
	{ SGBUTTON, SG_DEFAULT, 0, 21,15, 8,3, "OK" },
	{ SGBUTTON, 0, 0, 36,15, 10,1, "Quit" },
	{ SGBUTTON, SG_CANCEL, 0, 36,17, 10,1, "Cancel" },
	{ -1, 0, 0, 0,0, 0,0, NULL }
};

static SGOBJ virtualkeybdlg[] =
{
	{ SGBOX, 0, 0, 0,0, 57,15, NULL },
	{ SGTEXT, 0, 0, 17,1, 16,1, "Atari ST keyboard" },
	{ SGBUTTON, 0, 0, 2,3, 4,1, "F1" },
	{ SGBUTTON, 0, 0, 6,3, 4,1, "F2" },
	{ SGBUTTON, 0, 0, 10,3, 4,1, "F3" },
	{ SGBUTTON, 0, 0, 14,3, 4,1, "F4" },
	{ SGBUTTON, 0, 0, 18,3, 4,1, "F5" },
	{ SGBUTTON, 0, 0, 22,3, 4,1, "F6" },
	{ SGBUTTON, 0, 0, 26,3, 4,1, "F7" },
	{ SGBUTTON, 0, 0, 30,3, 4,1, "F8" },
	{ SGBUTTON, 0, 0, 34,3, 4,1, "F9" },
	{ SGBUTTON, 0, 0, 38,3, 4,1, "F10" },
	
	{ SGBUTTON, 0, 0, 2,5, 3,1, "Esc" },
	{ SGBUTTON, 0, 0, 5,5, 3,1, "1" },
	{ SGBUTTON, 0, 0, 8,5, 3,1, "2" },
	{ SGBUTTON, 0, 0, 11,5, 3,1, "3" },
	{ SGBUTTON, 0, 0, 14,5, 3,1, "4" },
	{ SGBUTTON, 0, 0, 17,5, 3,1, "5" },
	{ SGBUTTON, 0, 0, 20,5, 3,1, "6" },
	{ SGBUTTON, 0, 0, 23,5, 3,1, "7" },
	{ SGBUTTON, 0, 0, 26,5, 3,1, "8" },
	{ SGBUTTON, 0, 0, 29,5, 3,1, "9" },
	{ SGBUTTON, 0, 0, 32,5, 3,1, "0" },
	{ SGBUTTON, 0, 0, 35,5, 3,1, "-" },
	{ SGBUTTON, 0, 0, 38,5, 3,1, "=" },
	{ SGBUTTON, 0, 0, 41,5, 3,1, "`" },
	{ SGBUTTON, 0, 0, 44,5, 9,1, "Backspace" },

	{ SGBUTTON, 0, 0, 2,7, 5,1, "Tab" },
	{ SGBUTTON, 0, 0, 7,7, 3,1, "Q" },
	{ SGBUTTON, 0, 0, 10,7, 3,1, "W" },
	{ SGBUTTON, 0, 0, 13,7, 3,1, "E" },
	{ SGBUTTON, 0, 0, 16,7, 3,1, "R" },
	{ SGBUTTON, 0, 0, 19,7, 3,1, "T" },
	{ SGBUTTON, 0, 0, 22,7, 3,1, "Y" },
	{ SGBUTTON, 0, 0, 25,7, 3,1, "U" },
	{ SGBUTTON, 0, 0, 28,7, 3,1, "I" },
	{ SGBUTTON, 0, 0, 31,7, 3,1, "O" },
	{ SGBUTTON, 0, 0, 34,7, 3,1, "P" },
	{ SGBUTTON, 0, 0, 37,7, 3,1, "[" },
	{ SGBUTTON, 0, 0, 40,7, 3,1, "]" },
	{ SGBUTTON, 0, 0, 43,7, 6,3, "Return" },
	{ SGBUTTON, 0, 0, 50,7, 3,1, "Del" },

	{ SGBUTTON, 0, 0, 2,9, 8,1, "Control" },
	{ SGBUTTON, 0, 0, 9,9, 3,1, "A" },
	{ SGBUTTON, 0, 0, 12,9, 3,1, "S" },
	{ SGBUTTON, 0, 0, 15,9, 3,1, "D" },
	{ SGBUTTON, 0, 0, 18,9, 3,1, "F" },
	{ SGBUTTON, 0, 0, 21,9, 3,1, "G" },
	{ SGBUTTON, 0, 0, 24,9, 3,1, "H" },
	{ SGBUTTON, 0, 0, 27,9, 3,1, "J" },
	{ SGBUTTON, 0, 0, 30,9, 3,1, "K" },
	{ SGBUTTON, 0, 0, 33,9, 3,1, "L" },
	{ SGBUTTON, 0, 0, 36,9, 3,1, ";" },
	{ SGBUTTON, 0, 0, 39,9, 3,1, "'" },
	{ SGBUTTON, 0, 0, 50,9, 3,1, "#" },

	{ SGBUTTON, 0, 0, 2,11, 6,1, "Shift" },
	{ SGBUTTON, 0, 0, 7,11, 3,1, "\\" },
	{ SGBUTTON, 0, 0, 10,11, 3,1, "Z" },
	{ SGBUTTON, 0, 0, 13,11, 3,1, "X" },
	{ SGBUTTON, 0, 0, 16,11, 3,1, "C" },
	{ SGBUTTON, 0, 0, 19,11, 3,1, "V" },
	{ SGBUTTON, 0, 0, 22,11, 3,1, "B" },
	{ SGBUTTON, 0, 0, 25,11, 3,1, "N" },
	{ SGBUTTON, 0, 0, 28,11, 3,1, "M" },
	{ SGBUTTON, 0, 0, 31,11, 3,1, "," },
	{ SGBUTTON, 0, 0, 34,11, 3,1, "." },
	{ SGBUTTON, 0, 0, 37,11, 3,1, "/" },
	{ SGBUTTON, 0, 0, 40,11, 6,1, "Shift" },

	{ SGBUTTON, 0, 0, 7,13, 9,1, "Alternate" },
	{ SGBUTTON, 0, 0, 16,13, 20,1, " " },
	{ SGBUTTON, 0, 0, 36,13, 8,1, "CapsLock" },
	
	{ SGBUTTON, SG_DEFAULT, 0, 49,13, 5,1, "CLOSE" },
	{ SGCHECKBOX, 0, 0, 44,3, 3,1, "Long press" },

	{ -1, 0, 0, 0,0, 0,0, NULL }
};


//



/* Very basic virtual keyboard especially to launch games */
int Dialog_virtualkeybdlg(void)
{
	int keys;
	bool bOldMouseVisibility;
	int nOldMouseX, nOldMouseY;
	int i=0;
	int time=1;

	if (SDLGui_SetScreen(sdlscrn))
		return false;

	SDL_GetMouseState(&nOldMouseX, &nOldMouseY);
	bOldMouseVisibility = SDL_ShowCursor(SDL_QUERY);
	SDL_ShowCursor(SDL_ENABLE);

	SDLGui_CenterDlg(virtualkeybdlg);
		
	keys = SDLGui_DoDialog(virtualkeybdlg, NULL);


	/* Simulate a long press for some menu games etc... */
	if(virtualkeybdlg[KEYDLG_TIME].state & SG_SELECTED)
	time=90;

		switch (keys)
		{
		 case KEYDLG_F1: keypressed=59;break;
		 case KEYDLG_F2: keypressed=60;break;
		 case KEYDLG_F3: keypressed=61;break;
		 case KEYDLG_F4: keypressed=62;break;
		 case KEYDLG_F5: keypressed=63;break;
		 case KEYDLG_F6: keypressed=64;break;
		 case KEYDLG_F7: keypressed=65;break;
		 case KEYDLG_F8: keypressed=66;break;
		 case KEYDLG_F9: keypressed=67;break;
		 case KEYDLG_F10: keypressed=68;break;
		 	 
		 case KEYDLG_ESC: keypressed=1;break;	 
		 case KEYDLG_1:	keypressed=2;break;						
		 case KEYDLG_2:	keypressed=3;break;  							  					  
		 case KEYDLG_3:	keypressed=4;break;													
		 case KEYDLG_4:	keypressed=5;break;								
		 case KEYDLG_5:	keypressed=6;break;								
		 case KEYDLG_6:	keypressed=7;break;							
		 case KEYDLG_7:	keypressed=8;break;										
		 case KEYDLG_8:	keypressed=9;break;								
		 case KEYDLG_9:	keypressed=10;break;								
		 case KEYDLG_0:	keypressed=11;break;
		 case KEYDLG_10: keypressed=12;break;						
		 case KEYDLG_11: keypressed=13;break;
		 case KEYDLG_12: keypressed=41;break;
		 case KEYDLG_BACKSPACE: keypressed=14;break;		

		 case KEYDLG_TAB: keypressed=15;break;		
		 case KEYDLG_Q: keypressed=16;break;
		 case KEYDLG_W: keypressed=17;break;
		 case KEYDLG_E: keypressed=18;break;
		 case KEYDLG_R: keypressed=19;break;
		 case KEYDLG_T: keypressed=20;break;
		 case KEYDLG_Y: keypressed=21;break;
		 case KEYDLG_U: keypressed=22;break;
		 case KEYDLG_I: keypressed=23;break;
		 case KEYDLG_O: keypressed=24;break;
		 case KEYDLG_P: keypressed=25;break;
		 case KEYDLG_LBRACKET: keypressed=26;break;
		 case KEYDLG_RBRACKET: keypressed=27;break;
		 case KEYDLG_RETURN: keypressed=28;break;
		 case KEYDLG_DEL: keypressed=83;break;
		 
		 case KEYDLG_CONTROL: keypressed=29;break;
		 case KEYDLG_A: keypressed=30;break;
		 case KEYDLG_S: keypressed=31;break;
		 case KEYDLG_D: keypressed=32;break;
		 case KEYDLG_F: keypressed=33;break;
		 case KEYDLG_G: keypressed=34;break;
		 case KEYDLG_H: keypressed=35;break;
		 case KEYDLG_J: keypressed=36;break;
		 case KEYDLG_K: keypressed=37;break;
		 case KEYDLG_L: keypressed=38;break;
		 case KEYDLG_SEMICOLON: keypressed=39;break;
		 case KEYDLG_APOSTROPHE: keypressed=40;break;
		 case KEYDLG_SHARP: keypressed=43;break;
		 
		 case KEYDLG_LEFTSHIFT: keypressed=42;break;
		 case KEYDLG_BACKSLASH: keypressed=96;break;
		 case KEYDLG_Z: keypressed=44;break;
		 case KEYDLG_X: keypressed=45;break;
		 case KEYDLG_C: keypressed=46;break;
		 case KEYDLG_V: keypressed=47;break;
		 case KEYDLG_B: keypressed=48;break;
		 case KEYDLG_N: keypressed=49;break;
		 case KEYDLG_M: keypressed=50;break;
		 case KEYDLG_COLON: keypressed=51;break;
		 case KEYDLG_DOT: keypressed=52;break;
		 case KEYDLG_SLASH: keypressed=53;break;
		 case KEYDLG_RIGHTSHIFT: keypressed=54;break;
		 		 				
		 case KEYDLG_ALTERNATE: keypressed=56;break;
		 case KEYDLG_SPACE: keypressed=57;break;
		 case KEYDLG_CAPSLOCK: keypressed=58;break;
		 	
		 case KEYDLG_CLOSE: keypressed=-1;break;				
		 default: keypressed=-1;break;
		 			
		}
		
	SDL_ShowCursor(bOldMouseVisibility);
	Main_WarpMouse(nOldMouseX, nOldMouseY);

	Main_PauseEmulation(false);
	
	for(i=0;i<time;++i)
	{
		IKBD_PressSTKey(keypressed,true);
	}
	Main_UnPauseEmulation();
	IKBD_PressSTKey(keypressed,false);

	return 0;
}
//

/**
 * This functions sets up the actual font and then displays the main dialog.
 */
int Dialog_MainDlg(bool *bReset, bool *bLoadedSnapshot)
{
	int retbut;
	bool bOldMouseVisibility;
	int nOldMouseX, nOldMouseY;

	*bReset = false;
	*bLoadedSnapshot = false;

	if (SDLGui_SetScreen(sdlscrn))
		return false;

	SDL_GetMouseState(&nOldMouseX, &nOldMouseY);
	bOldMouseVisibility = SDL_ShowCursor(SDL_QUERY);
	SDL_ShowCursor(SDL_ENABLE);

	SDLGui_CenterDlg(maindlg);

	maindlg[MAINDLG_NORESET].state |= SG_SELECTED;
	maindlg[MAINDLG_RESET].state &= ~SG_SELECTED;

	do
	{
		retbut = SDLGui_DoDialog(maindlg, NULL);
		switch (retbut)
		{
		 case MAINDLG_ABOUT:
			Dialog_AboutDlg();
			break;
		 case MAINDLG_FLOPPYS:
		  //benoa DlgFloppy_Main();
			Dialog_DiskDlg();
		  //
			break;
		  //benoa	
	      //case MAINDLG_HARDDISK:
		  //DlgHardDisk_Main();
		  //break;
		 case MAINDLG_ROM:
			DlgRom_Main();
			break;
		 case MAINDLG_SCREEN:
			Dialog_ScreenDlg();
			break;
		 case MAINDLG_SOUND:
			Dialog_SoundDlg();
			break;
		 case MAINDLG_SYSTEM:
			Dialog_SystemDlg();
			break;
		 case MAINDLG_MEMORY:
			if (Dialog_MemDlg())
			{
				/* Memory snapshot has been loaded - leave GUI immediately */
				*bLoadedSnapshot = true;
				return true;
			}
			break;
		 case MAINDLG_JOY:
			Dialog_JoyDlg();
			break;
		 case MAINDLG_KEYBD:
			Dialog_KeyboardDlg();
			break;
		 case MAINDLG_DEVICES:
			Dialog_DeviceDlg();
			break;
		 case MAINDLG_LOADCFG:
			Configuration_Load(NULL);
			break;
		 case MAINDLG_SAVECFG:
			Configuration_Save();
			break;
		 case MAINDLG_QUIT:
			bQuitProgram = true;
			break;
		}
	}
	while (retbut != MAINDLG_OK && retbut != MAINDLG_CANCEL && retbut != SDLGUI_QUIT
	        && retbut != SDLGUI_ERROR && !bQuitProgram);


	if (maindlg[MAINDLG_RESET].state & SG_SELECTED)
		*bReset = TRUE;
else
		*bReset = FALSE;

	SDL_ShowCursor(bOldMouseVisibility);
	Main_WarpMouse(nOldMouseX, nOldMouseY);

	return (retbut == MAINDLG_OK);
}
